<?

class CSession {
  var $vars;
  var $cookiePrefix;
  var $cookiePath;
  var $cookieDomain;
  var $cookieSecure;
  var $varsCookieName;

  ////////////////////////////////////////////////////////////////////////////
  function CSession($cookiePrefix, $cookieDomain = '', $cookiePath = '', $cookieSecure = 0) {
    global $HTTP_COOKIE_VARS;

    $this->cookiePrefix = $cookiePrefix;
    $this->cookiePath = $cookiePath;
    $this->cookieDomain = $cookieDomain;
    $this->cookieSecure = $cookieSecure;
    $this->varsCookieName = $cookiePrefix . '_vars';

    if (isset($HTTP_COOKIE_VARS[$this->varsCookieName])) {
      // get session variables
      $this->vars = unserialize(stripslashes($HTTP_COOKIE_VARS[$this->varsCookieName]));
      if (is_array($this->vars)) {
        foreach ($this->vars as $k => $v) {
          $GLOBALS[$k] = $v;
        }
      }
    }
  }

  ////////////////////////////////////////////////////////////////////////////
  function register($name) {
    $this->vars[$name] = $GLOBALS[$name];
    setcookie($this->varsCookieName, serialize($this->vars), 0, $this->cookiePath, $this->cookieDomain, $this->cookieSecure);
  }

  ////////////////////////////////////////////////////////////////////////////
  function unregister($name) {
    unset($this->vars[$name]);
    setcookie($this->varsCookieName, serialize($this->vars), 0, $this->cookiePath, $this->cookieDomain, $this->cookieSecure);
  }
}

?>
